/*
 * 7SEG LED4 \tgEFASPI_Ci~bNXLTvi\tgEFAfBCj@Version 1.00
 * File:        7seg4c2.c
 * Target:      PIC18F46K22 64MHz
 * RpC:   Microchip MPLAB XC8 C Compiler V1.20
 * :     PICKit 3
 * [X:     2014/02/07 21:30
 * IO|[gSPĨf[^쐬 74HC595ɐڑꂽLED00009999܂1JEgȂ\B
 * ڑ(MSPP2W[Ɠs)
 *   SCK2(RD0),SDO2(RD4),SS2(RD3)
 * LED̃f[^tH[}bg
 *   MSB xxxxdddd LSB
 *   xxxx͊erbgʒuɑΉ(Lœ_)
 *   dddd͌f[^
*/

#include <p18f46k22.h>
#include <plib\delays.h>

#pragma config  FOSC = HSHP,PRICLKEN=ON,PLLCFG=ON,WDTEN=OFF,LVP=OFF

#define SCK PORTDbits.RD0
#define SS  PORTDbits.RD3
#define SDO PORTDbits.RD4

void SPI2rw(unsigned char w); // \tgSPIo
void disp_7seg(unsigned w);    //  W10iƂ݂Ȃ7SEG\f[^ݒ

void main(void){
    ANSELDbits.ANSD0=0; //  SCK2
    ANSELDbits.ANSD3=0; //  SS2
    ANSELDbits.ANSD4=0; //  SDO2
    SS=0;
    SCK=0;
    SDO=0;
    TRISDbits.RD3=0;
    TRISDbits.RD0=0;
    TRISDbits.RD4=0;

    SPI2rw(0xff);   // LED

    for(;;)
        for(int n=0;n<10000;n++){
            for(unsigned char w=0;w<50;w++)
                disp_7seg(n);
       }
}

// \tgSPIo

void SPI2rw(unsigned char w){
    SS=0;
    for(unsigned char  n=0;n<8;n++){
        SCK=0;
        SDO = (w & 0x80) ? 1 : 0;
        SCK=1;
        w=w<<1;
    }
    SS=1;
}

void disp_7seg(unsigned w){    //  W10iƂ݂Ȃ7SEG\
    unsigned d;
    d=w % 10;
    SPI2rw(0xe0+d);      //  1
    Delay100TCYx( 160);  // 64MHz/4*1mb/100
    d=(w/10) % 10;
    SPI2rw(0xd0+d);      //  2
    Delay100TCYx( 160);  // 64MHz/4*1mb/100

    d=(w/100) % 10;
    SPI2rw(0xb0+d);      //  3
    Delay100TCYx( 160);  // 64MHz/4*1mb/100

    d=(w/1000) % 10;
    SPI2rw(0x70+d);      //  4
    Delay100TCYx( 160);  // 64MHz/4*1mb/100
}
